## eckit 1.28.5

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################


cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( eckit LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()

### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_BUILDERS_DEBUG
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory builders debug"
                    ADVANCED )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_EMPTY_DESTRUCTION
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory empty destruction (system dependant)"
                    ADVANCED )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_find_lexyacc()

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    CONDITION LEXYACC_FOUND
                    REQUIRED_PACKAGES "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    CONDITION LEXYACC_FOUND )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### OpenMP

ecbuild_add_option( FEATURE OMP
                    DEFAULT OFF
                    DESCRIPTION "OpenMP linear algebra backend"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS CXX" )

if( NOT TARGET OpenMP::OpenMP_CXX )
    set( eckit_HAVE_OMP 0 )
endif()

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression options

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### Hashing options

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "xxHash support for hashing" )

### eckit::codec

ecbuild_add_option( FEATURE ECKIT_CODEC
                    DEFAULT ON
                    DESCRIPTION "eckit::codec encoding/decoding library" )

set( eckit_CODEC_STATIC_ASSERT ON CACHE BOOL "eckit::codec static assertions" )

### eckit::maths

ecbuild_add_option( FEATURE CONVEX_HULL
                    DEFAULT OFF
                    DESCRIPTION "eckit::maths library convex hull/Delaunay triangulation" )
                    # REQUIRED_PACKAGES "Qhull COMPONENTS C CXX"

if( eckit_HAVE_CONVEX_HULL )
    find_package( Qhull REQUIRED CONFIG )

    if( NOT TARGET Qhull::qhullcpp OR NOT TARGET Qhull::qhullstatic_r )
        message( FATAL_ERROR "eckit::maths ENABLE_CONVEX_HULL requires Qhull C/C++ libraries" )
    endif()

    add_library(Qhull::Qhull INTERFACE IMPORTED)
    target_link_libraries(Qhull::Qhull INTERFACE Qhull::qhullcpp Qhull::qhullstatic_r )
endif()

### eckit::geo

ecbuild_add_option( FEATURE ECKIT_GEO
                    DEFAULT OFF
                    DESCRIPTION "eckit::geo geometry library" )

ecbuild_add_option( FEATURE GEO_GRID_ORCA
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4
                    DESCRIPTION "eckit::geo geometry library support for ORCA grids" )

ecbuild_add_option( FEATURE GEO_CACHING
                    DEFAULT OFF
                    CONDITION HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default caching behaviour" )

ecbuild_add_option( FEATURE GEO_BITREPRODUCIBLE
                    DEFAULT OFF
                    CONDITION HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library bit reproducibility tests" )

ecbuild_add_option( FEATURE GEO_PROJECTION_PROJ_DEFAULT
                    DEFAULT OFF
                    CONDITION HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default to PROJ-based projections" )

set( eckit_GEO_CACHE_PATH "/tmp/cache" )

### LAPACK

if( eckit_HAVE_MKL )
    set( eckit_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1 and MD4)

ecbuild_add_option( FEATURE SSL
                    DEFAULT OFF # We only use deprecated functionality from OpenSSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES "CURL 7.20" )

if(HAVE_CURL)
  ecbuild_info("Curl version ${CURL_VERSION_STRING} -- libs [${CURL_LIBRARIES}] incs [${CURL_INCLUDE_DIRS}]")
endif()

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    DEFAULT OFF
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### LibRsync

ecbuild_add_option( FEATURE RSYNC
                    DEFAULT OFF
                    DESCRIPTION "librsync implementation of the rsync algorithm"
                    REQUIRED_PACKAGES LibRsync )
if( HAVE_RSYNC )
  set( LIBRSYNC_LIBRARIES rsync )
endif()


### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### UNICODE support

check_include_file_cxx("codecvt" HAVE_CXX_CODECVT)

ecbuild_add_option( FEATURE UNICODE
                    DEFAULT ON
                    CONDITION HAVE_CXX_CODECVT
                    DESCRIPTION "Add support for Unicode characters in Yaml/JSON parsers" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### PROJ support

ecbuild_add_option( FEATURE PROJ
                    DEFAULT OFF
                    DESCRIPTION "support PROJ-based projections"
                    REQUIRED_PACKAGES "PROJ 9.2" )

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
  set( RT_LIBRARIES "" )
endif()

### sanity checks

include(cmake/check_time_t_Y2038.cmake) # check Y2038 time_t compatibility

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# sources

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

add_subdirectory( src )
add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( etc )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files
                       SOURCES AUTHORS README.md NOTICE LICENSE
                       INSTALL ChangeLog COPYING )

############################################################################################
# finalize

set( ECKIT_LIBRARIES ${eckit_ALL_LIBS} ) # used for ecbuild_pkgconfig

foreach( _lib ${ECKIT_LIBRARIES} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== tests/codec/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_test(
    TARGET  eckit_test_codec_encoding
    SOURCES test_codec_encoding.cc
    LIBS    eckit_codec
)

ecbuild_add_test(
    TARGET  eckit_test_codec_stream
    SOURCES test_codec_stream.cc
    LIBS    eckit_codec
)

ecbuild_add_executable(
    TARGET  eckit_test_codec_record
    SOURCES test_codec_record.cc
    LIBS    eckit_codec
    NOINSTALL
)

foreach( algorithm none bzip2 aec lz4 snappy )
    string( TOUPPER ${algorithm} feature )
    if( eckit_HAVE_${feature} OR algorithm MATCHES "none" )
        ecbuild_add_test(
            TARGET      eckit_test_codec_record_COMPRESSION_${algorithm}
            COMMAND     eckit_test_codec_record
            ARGS        --suffix ".${algorithm}"
            ENVIRONMENT ECKIT_CODEC_COMPRESSION=${algorithm}
        )
    endif()
endforeach()

=== tests/maths/CMakeLists.txt ===
ecbuild_add_test(
    TARGET    eckit_test_maths_eigen
    SOURCES   test_eigen.cc
    CONDITION HAVE_EIGEN
    LIBS      eckit_maths eckit
)

foreach( _test matrix matrix3 )
    ecbuild_add_test(
        TARGET  eckit_test_maths_${_test}
        SOURCES test_${_test}.cc
        LIBS    eckit_maths eckit
    )
endforeach()

ecbuild_add_test(
    TARGET    eckit_test_maths_convex_hull
    SOURCES   test_convex_hull.cc
    CONDITION HAVE_CONVEX_HULL
    LIBS      eckit_maths eckit
)

=== tests/utils/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
2t_sfc.grib
2t_sfc_regrid.grib
vo-d_6ml.grib
u-v_6ml.grib
q_6ml_regrid.grib
)

if(HAVE_EXTRA_TESTS)
        ecbuild_get_test_multidata( TARGET get_eckit_test_data
                                    NAMES ${test_data_files}
                                    NOCHECK )
endif()

ecbuild_add_test( TARGET      eckit_test_utils_byteswap
                  SOURCES     test_byteswap.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_string_tools
                  SOURCES     test_string_tools.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_translator
                  SOURCES     test_translator.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_tokenizer
                  SOURCES     test_tokenizer.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_semanticversion
                  SOURCES     test_semanticversion.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_rendezvoushash
                  SOURCES     test_rendezvoushash.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compressor
                  SOURCES     test_compressor.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_optional
                  SOURCES     test_optional.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hashing
                  CONDITION   eckit_HAVE_SSL
                  INCLUDES    "${OPENSSL_INCLUDE_DIR}"
                  SOURCES     test_hashing.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hash_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  SOURCES     hash-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compression_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  TEST_DEPENDS get_eckit_test_data
                  SOURCES     compression-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_rsync
                  CONDITION   HAVE_RSYNC
                  SOURCES     test_rsync.cc
                  LIBS        eckit rsync )

ecbuild_add_test( TARGET      eckit_test_regex
                  SOURCES     test_regex.cc
                  LIBS        eckit )

=== src/eckit/geo/CMakeLists.txt ===

list(APPEND eckit_geo_srcs
    Area.cc
    Area.h
    Cache.cc
    Cache.h
    Figure.cc
    Figure.h
    GreatCircle.cc
    GreatCircle.h
    Grid.cc
    Grid.h
    Increments.cc
    Increments.h
    Iterator.cc
    Iterator.h
    LibEcKitGeo.cc
    LibEcKitGeo.h
    Ordering.cc
    Ordering.h
    Point.cc
    Point.h
    Point2.cc
    Point2.h
    Point3.cc
    Point3.h
    PointLonLat.cc
    PointLonLat.h
    PointLonLatR.cc
    PointLonLatR.h
    Projection.cc
    Projection.h
    Range.cc
    Range.h
    Renumber.h
    Search.h
    Shape.cc
    Shape.h
    Spec.cc
    Spec.h
    area/BoundingBox.cc
    area/BoundingBox.h
    etc/Grid.cc
    etc/Grid.h
    figure/Earth.cc
    figure/Earth.h
    figure/OblateSpheroid.cc
    figure/OblateSpheroid.h
    figure/Sphere.cc
    figure/Sphere.h
    figure/UnitSphere.cc
    figure/UnitSphere.h
    geometry/OblateSpheroid.cc
    geometry/OblateSpheroid.h
    geometry/Sphere.cc
    geometry/Sphere.h
    geometry/SphereT.h
    geometry/UnitSphere.h
    grid/HEALPix.cc
    grid/HEALPix.h
    grid/Reduced.cc
    grid/Reduced.h
    grid/ReducedGaussian.cc
    grid/ReducedGaussian.h
    grid/ReducedLL.cc
    grid/ReducedLL.h
    grid/Regular.cc
    grid/Regular.h
    grid/RegularGaussian.cc
    grid/RegularGaussian.h
    grid/RegularLL.cc
    grid/RegularLL.h
    grid/RegularXY.cc
    grid/RegularXY.h
    grid/Unstructured.cc
    grid/Unstructured.h
    grid/regular-xy/LambertAzimuthalEqualArea.cc
    grid/regular-xy/LambertAzimuthalEqualArea.h
    grid/regular-xy/LambertConformalConic.cc
    grid/regular-xy/LambertConformalConic.h
    grid/regular-xy/Mercator.cc
    grid/regular-xy/Mercator.h
    grid/regular-xy/PolarStereographic.cc
    grid/regular-xy/PolarStereographic.h
    grid/regular-xy/SpaceView.cc
    grid/regular-xy/SpaceView.h
    iterator/Reduced.cc
    iterator/Reduced.h
    iterator/Regular.cc
    iterator/Regular.h
    iterator/Unstructured.cc
    iterator/Unstructured.h
    polygon/LonLatPolygon.cc
    polygon/LonLatPolygon.h
    polygon/Polygon.cc
    polygon/Polygon.h
    projection/Composer.cc
    projection/Composer.h
    projection/LambertAzimuthalEqualArea.cc
    projection/LambertAzimuthalEqualArea.h
    projection/LambertConformalConic.cc
    projection/LambertConformalConic.h
    projection/LonLatToXYZ.cc
    projection/LonLatToXYZ.h
    projection/Mercator.cc
    projection/Mercator.h
    projection/None.cc
    projection/None.h
    projection/PolarStereographic.cc
    projection/PolarStereographic.h
    projection/ProjectionOnFigure.cc
    projection/ProjectionOnFigure.h
    projection/Reverse.h
    projection/Rotation.cc
    projection/Rotation.h
    projection/SpaceView.cc
    projection/SpaceView.h
    projection/Stretch.cc
    projection/Stretch.h
    projection/XYToLonLat.cc
    projection/XYToLonLat.h
    range/GaussianLatitude.cc
    range/GaussianLatitude.h
    range/Regular.cc
    range/Regular.h
    range/RegularCartesian.cc
    range/RegularCartesian.h
    range/RegularLatitude.cc
    range/RegularLatitude.h
    range/RegularLongitude.cc
    range/RegularLongitude.h
    spec/Custom.cc
    spec/Custom.h
    spec/Generator.h
    spec/Layered.cc
    spec/Layered.h
    util.cc
    util.h
    util/arange.cc
    util/bounding_box.cc
    util/gaussian_latitudes.cc
    util/linspace.cc
    util/monotonic_crop.cc
    util/mutex.h
    util/reduced_classical_pl.cc
    util/reduced_octahedral_pl.cc
    util/sincos.h
)

set(eckit_geo_include_dirs
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
)

set(eckit_geo_libs eckit_maths)
set(eckit_GEO_ETC_GRID "~eckit/etc/eckit/geo/grid.yaml")

if(eckit_HAVE_PROJ)
    list(APPEND eckit_geo_srcs projection/PROJ.cc projection/PROJ.h)
    list(APPEND eckit_geo_libs PROJ::proj)
endif()

if(eckit_HAVE_GEO_GRID_ORCA)
    list(APPEND eckit_geo_srcs grid/ORCA.cc grid/ORCA.h)
    list(APPEND eckit_geo_libs eckit_codec)
    list(APPEND eckit_GEO_ETC_GRID "~eckit/etc/eckit/geo/ORCA.yaml")
endif()

string(REPLACE ";" ":" eckit_GEO_ETC_GRID "${eckit_GEO_ETC_GRID}")
configure_file(eckit_geo_config.h.in eckit_geo_config.h @ONLY)

list(APPEND eckit_geo_srcs ${CMAKE_CURRENT_BINARY_DIR}/eckit_geo_config.h)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/eckit_geo_config.h
    DESTINATION ${INSTALL_INCLUDE_DIR}/eckit
)

ecbuild_add_library(
    TARGET             eckit_geo
    TYPE               SHARED
    INSTALL_HEADERS    ALL
    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/geo
    PUBLIC_LIBS        ${eckit_geo_libs}
    PUBLIC_INCLUDES    ${eckit_geo_include_dirs}
    SOURCES            ${eckit_geo_srcs}
)

=== src/eckit/sql/CMakeLists.txt ===
list( APPEND eckit_sql_lib_srcs

#SQLMATCHSubquerySession.h
#SQLMATCHSubquerySession.cc
#SQLMATCHSubquerySessionOutput.h
#SQLMATCHSubquerySessionOutput.cc
Environment.cc
Environment.h
SQLBitColumn.cc
SQLBitColumn.h
SQLColumn.cc
SQLColumn.h
SQLDatabase.cc
SQLDatabase.h
SQLDistinctOutput.cc
SQLDistinctOutput.h
SQLOrderOutput.cc
SQLOrderOutput.h
SQLOutput.cc
SQLOutput.h
SQLOutputConfig.cc
SQLOutputConfig.h
SQLParser.cc
SQLParser.h
SelectOneTable.cc
SelectOneTable.h
SQLSelect.cc
SQLSelect.h
SQLSelectFactory.cc
SQLSelectFactory.h
SQLSession.cc
SQLSession.h
SQLSimpleOutput.cc
SQLSimpleOutput.h
SQLStatement.cc
SQLStatement.h
SQLTable.cc
SQLTable.h
SQLTableFactory.cc
SQLTableFactory.h
SQLTypedefs.h

SchemaAnalyzer.cc
SchemaAnalyzer.h
SchemaComponents.cc
SchemaComponents.h

expression/BitColumnExpression.cc
expression/BitColumnExpression.h
expression/ColumnExpression.cc
expression/ColumnExpression.h
expression/ConstantExpression.cc
expression/ConstantExpression.h
expression/NumberExpression.cc
expression/NumberExpression.h
expression/ParameterExpression.cc
expression/ParameterExpression.h
expression/StringExpression.cc
expression/StringExpression.h
expression/SQLExpression.cc
expression/SQLExpression.h
expression/SQLExpressions.cc
expression/SQLExpressions.h
expression/ShiftedColumnExpression.cc
expression/ShiftedColumnExpression.h
expression/SQLExpressionEvaluated.cc
expression/SQLExpressionEvaluated.h
expression/OrderByExpressions.cc
expression/OrderByExpressions.h

expression/function/DoubleFunctions.cc
expression/function/FunctionExpression.cc
expression/function/FunctionExpression.h
expression/function/FunctionAND.cc
expression/function/FunctionAND.h
expression/function/FunctionAVG.cc
expression/function/FunctionAVG.h
expression/function/FunctionCOUNT.cc
expression/function/FunctionCOUNT.h
expression/function/FunctionDOTP.cc
expression/function/FunctionDOTP.h
expression/function/FunctionEQ.cc
expression/function/FunctionEQ.h
expression/function/FunctionRLIKE.cc
expression/function/FunctionRLIKE.h
#expression/function/FunctionMATCH.h
#expression/function/FunctionMATCH.cc
expression/function/FunctionFactory.cc
expression/function/FunctionFactory.h
expression/function/FunctionIN.cc
expression/function/FunctionIN.h
expression/function/FunctionIntegerExpression.cc
expression/function/FunctionIntegerExpression.h
expression/function/FunctionJOIN.cc
expression/function/FunctionJOIN.h
expression/function/FunctionJULIAN.cc
expression/function/FunctionJULIAN.h
expression/function/FunctionJULIAN_SECONDS.cc
expression/function/FunctionJULIAN_SECONDS.h
expression/function/FunctionMAX.cc
expression/function/FunctionMAX.h
expression/function/FunctionMIN.cc
expression/function/FunctionMIN.h
expression/function/FunctionFIRST.cc
expression/function/FunctionFIRST.h
expression/function/FunctionLAST.cc
expression/function/FunctionLAST.h
expression/function/FunctionNORM.cc
expression/function/FunctionNORM.h
expression/function/FunctionNE.cc
expression/function/FunctionNE.h
expression/function/FunctionNOT_IN.cc
expression/function/FunctionNOT_IN.h
expression/function/FunctionNOT_NULL.cc
expression/function/FunctionNOT_NULL.h
expression/function/FunctionNULL.cc
expression/function/FunctionNULL.h
expression/function/FunctionNVL.cc
expression/function/FunctionNVL.h
expression/function/FunctionOR.cc
expression/function/FunctionOR.h
expression/function/FunctionRMS.cc
expression/function/FunctionRMS.h
expression/function/FunctionROWNUMBER.cc
expression/function/FunctionROWNUMBER.h
expression/function/FunctionSTDEV.cc
expression/function/FunctionSTDEV.h
expression/function/FunctionSUM.cc
expression/function/FunctionSUM.h
expression/function/FunctionTDIFF.cc
expression/function/FunctionTDIFF.h
expression/function/FunctionTHIN.cc
expression/function/FunctionTHIN.h
expression/function/FunctionTIMESTAMP.cc
expression/function/FunctionTIMESTAMP.h
expression/function/FunctionVAR.cc
expression/function/FunctionVAR.h

type/SQLBit.cc
type/SQLBit.h
type/SQLBitfield.cc
type/SQLBitfield.h
type/SQLDouble.cc
type/SQLDouble.h
type/SQLInt.cc
type/SQLInt.h
type/SQLReal.cc
type/SQLReal.h
type/SQLString.cc
type/SQLString.h
type/SQLType.cc
type/SQLType.h
)


ecbuild_generate_yy( YYPREFIX           eckit_sql_
                     YACC               sqly
                     LEX                sqll
                     FLEX_FLAGS         "-d"
                     DEPENDANT          SQLParser.cc )

if( NOT ENABLE_WARNINGS )
    # Warnings present in autogenerated files based on sqly and sqll
    list( APPEND suppress_warnings
      $<$<CXX_COMPILER_ID:GNU>:-Wno-unused-function>
      $<$<CXX_COMPILER_ID:GNU>:-Wno-sign-compare>
      $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-register>
    )
    set_source_files_properties( SQLParser.cc PROPERTIES COMPILE_OPTIONS "${suppress_warnings}" )
endif()

ecbuild_add_library( TARGET              eckit_sql TYPE SHARED
                     INSTALL_HEADERS     ALL
                     HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/sql
                     SOURCES             ${eckit_sql_lib_srcs}
                     TEMPLATES
                                         SQLIteratorOutput.cc
                                         expression/ShiftedColumnExpression.cc
                     PUBLIC_LIBS         eckit )

# Disable all warnings for PGI/NVHPC compiler as it is overzealous and cherry-picking is not possible
target_compile_options( eckit_sql PRIVATE $<$<CXX_COMPILER_ID:PGI>:-w> $<$<CXX_COMPILER_ID:NVHPC>:-w> )

=== debian/changelog ===
eckit (1.28.5-2) unstable; urgency=medium

  * Enable rados: uses rados.patch
  * Add more archs for rados
  * Standards-Version: 4.7.1

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Feb 2025 16:18:15 +0000

eckit (1.28.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 29 Jan 2025 04:59:38 +0000

=== debian/control ===
Source: eckit
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.6.1-1~),
  chrpath,
  flex,
  bison,
  libopenblas-dev [ !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  libjemalloc-dev,
  librados-dev,
  libradospp-dev,
  libproj-dev, 
  libbz2-dev,
  liblz4-dev,
  libeigen3-dev,
  libsnappy-dev,
  librsync-dev,
  libqhull-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev (>=  7.20),
  libncurses-dev
Standards-Version: 4.7.1
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  mpi-default-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libjemalloc-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

DO_TEST:=true

include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1


# JEMALLOC Turned off as it breaks magics-python currently (TLS space)

BUILD_FLAGS = \ -DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DENABLE_RSYNC=On \
	-DENABLE_CONVEX_HULL=On \
	-DENABLE_SSL=On \
	-DENABLE_ECKIT_GEO=On \
	-DENABLE_PROJ=On \
	-DENABLE_RADOS=On \
	-DENABLE_OMP=On \
	-DENABLE_JEMALLOC=Off

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*

override_dh_auto_configure:
	dh_auto_configure --  ${BUILD_FLAGS} 
	( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*/*.so.0d
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf/eckit/tags .*/v?(\d\d?\d?\..+).tar\.gz

## eckit 1.28.6

=== debian/changelog ===
eckit (1.28.6-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 22 Mar 2025 11:26:15 +0000

## eckit 1.28.7

=== debian/changelog ===
eckit (1.28.7-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Apr 2025 08:34:41 +0100

## eckit 1.29.1%2Breally.1.28.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -305,7 +305,7 @@
 ecbuild_add_option( FEATURE PROJ
                     DEFAULT OFF
                     DESCRIPTION "support PROJ-based projections"
-                    REQUIRED_PACKAGES "PROJ 9.2" )
+                    REQUIRED_PACKAGES "PROJ 9.1.1" )
 
 ### c math library, needed when including "math.h"

=== src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( eckit_BIG_ENDIAN    1 )
        set( eckit_LITTLE_ENDIAN 0 )
else()
        set( eckit_BIG_ENDIAN    0 )
        set( eckit_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${eckit_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${eckit_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  eckit_HAVE_DLFCN_H )

if(NOT eckit_HAVE_DLFCN_H)
message(FATAL_ERROR "eckit requires dlfcn.h for supporting dlopen of shared libraries")
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        eckit_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS "sys/mman.h"  eckit_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON      "sys/mman.h"  eckit_HAVE_MAP_ANON )
check_symbol_exists( funopen       "stdio.h"     eckit_HAVE_FUNOPEN )
check_symbol_exists( fsync         "unistd.h"    eckit_HAVE_FSYNC)
check_symbol_exists( fdatasync     "unistd.h"    eckit_HAVE_FDATASYNC)
check_symbol_exists( F_FULLFSYNC   "fcntl.h"     eckit_HAVE_F_FULLFSYNC)
check_symbol_exists( fmemopen      "stdio.h"     eckit_HAVE_FMEMOPEN )
check_symbol_exists( dlinfo        "dlfcn.h"     eckit_HAVE_DLINFO)

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    eckit_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    eckit_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    eckit_HAVE_CXXABI_H )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    eckit_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    eckit_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    eckit_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    eckit_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    eckit_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
			${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h deprecated.h ${CMAKE_CURRENT_BINARY_DIR}/eckit_version.cc )

list( APPEND eckit_container_srcs
    container/BSPTree.h
    container/BTree.cc
    container/BTree.h
    container/BloomFilter.cc
    container/BloomFilter.h
    container/Cache.h
    container/CacheLRU.cc
    container/CacheLRU.h
    container/CacheManager.cc
    container/CacheManager.h
    container/ClassExtent.h
    container/DenseMap.h
    container/DenseSet.h
    container/KDMapped.cc
    container/KDMapped.h
    container/KDMemory.h
    container/KDTree.h
    container/MappedArray.cc
    container/MappedArray.h
    container/Queue.h
    container/Recycler.h
    container/SharedMemArray.cc
    container/SharedMemArray.h
    container/StatCollector.h
    container/Trie.cc
    container/Trie.h
    container/bsptree/BSPHyperPlane.h
    container/bsptree/BSPNode.cc
    container/bsptree/BSPNode.h
    container/kdtree/KDNode.cc
    container/kdtree/KDNode.h
    container/sptree/SPIterator.h
    container/sptree/SPMetadata.h
    container/sptree/SPNode.h
    container/sptree/SPNodeInfo.h
    container/sptree/SPNodeQueue.h
    container/sptree/SPTree.h
    container/sptree/SPValue.h
)

list( APPEND eckit_io_srcs
    io/AIOHandle.cc
    io/AIOHandle.h
    io/AsyncHandle.cc
    io/AsyncHandle.h
    io/AutoCloser.h
    io/Base64.cc
    io/Base64.h
    io/BitIO.cc
    io/BitIO.h
    io/Buffer.cc
    io/Buffer.h
    io/BufferCache.cc
    io/BufferCache.h
    io/BufferList.cc
    io/BufferList.h
    io/BufferedHandle.cc
    io/BufferedHandle.h
    io/CircularBuffer.cc
    io/CircularBuffer.h
    io/CommandStream.cc
    io/CommandStream.h
    io/Compress.cc
    io/Compress.h
    io/DataHandle.cc
    io/DataHandle.h
    io/DblBuffer.cc
    io/DblBuffer.h
    io/EmptyHandle.cc
    io/EmptyHandle.h
    io/FDataSync.cc
    io/FDataSync.h
    io/FOpenDataHandle.cc
    io/FTPHandle.cc
    io/FTPHandle.h
    io/FileBase.cc
    io/FileBase.h
    io/FileDescHandle.cc
    io/FileDescHandle.h
    io/FileHandle.cc
    io/FileHandle.h
    io/FileLock.cc
    io/FileLock.h
    io/FileLocker.cc
    io/FileLocker.h
    io/FilePool.cc
    io/FilePool.h
    io/HandleBuf.cc
    io/HandleBuf.h
    io/HandleHolder.cc
    io/HandleHolder.h
    io/Length.cc
    io/Length.h
    io/MMappedFileHandle.cc
    io/MMappedFileHandle.h
    io/MemoryHandle.cc
    io/MemoryHandle.h
    io/MoverTransfer.cc
    io/MoverTransfer.h
    io/MoverTransferSelection.cc
    io/MoverTransferSelection.h
    io/MultiHandle.cc
    io/MultiHandle.h
    io/MultiSocketHandle.cc
    io/MultiSocketHandle.h
    io/Offset.cc
    io/Offset.h
    io/PartFileHandle.cc
    io/PartFileHandle.h
    io/PartHandle.cc
    io/PartHandle.h
    io/PeekHandle.cc
    io/PeekHandle.h
    io/PipeHandle.cc
    io/PipeHandle.h
    io/Pipeline.cc
    io/Pipeline.h
    io/PooledFile.cc
    io/PooledFile.h
    io/PooledFileDescriptor.cc
    io/PooledFileDescriptor.h
    io/PooledHandle.cc
    io/PooledHandle.h
    io/RawFileHandle.cc
    io/RawFileHandle.h
    io/ResizableBuffer.h
    io/SeekableHandle.cc
    io/SeekableHandle.h
    io/Select.cc
    io/Select.h
    io/SharedBuffer.cc
    io/SharedBuffer.h
    io/SharedHandle.cc
    io/SharedHandle.h
    io/SockBuf.cc
    io/SockBuf.h
    io/StatsHandle.cc
    io/StatsHandle.h
    io/StdFile.cc
    io/StdFile.h
    io/StdPipe.cc
    io/StdPipe.h
    io/StdioBuf.cc
    io/StdioBuf.h
    io/TCPHandle.cc
    io/TCPHandle.h
    io/TCPSocketHandle.cc
    io/TCPSocketHandle.h
    io/TeeHandle.cc
    io/TeeHandle.h
    io/TransferWatcher.cc
    io/TransferWatcher.h
    io/cluster/ClusterDisks.cc
    io/cluster/ClusterDisks.h
    io/cluster/ClusterNode.cc
    io/cluster/ClusterNode.h
    io/cluster/ClusterNodes.cc
    io/cluster/ClusterNodes.h
    io/cluster/NodeInfo.cc
    io/cluster/NodeInfo.h
)

if(HAVE_CURL)
    list(APPEND eckit_io_srcs
        io/EasyCURL.cc
        io/EasyCURL.h
        io/URLHandle.cc
        io/URLHandle.h
    )
endif()

list(APPEND eckit_message_srcs
    message/Decoder.cc
    message/Decoder.h
    message/Message.cc
    message/Message.h
    message/MessageContent.cc
    message/MessageContent.h
    message/Reader.cc
    message/Reader.h
    message/Splitter.cc
    message/Splitter.h
)

if(HAVE_RADOS)
    list( APPEND eckit_io_srcs
        io/rados/RadosHandle.cc
        io/rados/RadosHandle.h
        io/rados/RadosCluster.h
        io/rados/RadosCluster.cc
        io/rados/RadosReadHandle.cc
        io/rados/RadosReadHandle.h
        io/rados/RadosWriteHandle.cc
        io/rados/RadosWriteHandle.h
        io/rados/RadosObject.h
        io/rados/RadosObject.cc
        io/rados/RadosAttributes.h
        io/rados/RadosAttributes.cc
    )
endif()

list( APPEND eckit_filesystem_srcs
    filesystem/BasePathName.cc
    filesystem/BasePathName.h
    filesystem/BasePathNameT.cc
    filesystem/BasePathNameT.h
    filesystem/FileMode.cc
    filesystem/FileMode.h
    filesystem/FileSpace.cc
    filesystem/FileSpace.h
    filesystem/FileSpaceStrategies.cc
    filesystem/FileSpaceStrategies.h
    filesystem/FileSystem.cc
    filesystem/FileSystem.h
    filesystem/FileSystemSize.h
    filesystem/LocalPathName.cc
    filesystem/LocalPathName.h
    filesystem/PathExpander.cc
    filesystem/PathExpander.h
    filesystem/PathName.cc
    filesystem/PathName.h
    filesystem/PathNameFactory.cc
    filesystem/PathNameFactory.h
    filesystem/TempFile.cc
    filesystem/TempFile.h
    filesystem/TmpDir.cc
    filesystem/TmpDir.h
    filesystem/StdDir.cc
    filesystem/StdDir.h
    filesystem/TmpFile.cc
    filesystem/TmpFile.h
    filesystem/URI.cc
    filesystem/URI.h
    filesystem/URIManager.cc
    filesystem/URIManager.h
    filesystem/LocalFileManager.cc
    filesystem/LocalFileManager.h
)

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
    config/Configurable.cc
    config/Configurable.h
    config/Configuration.cc
    config/Configuration.h
    config/Configured.cc
    config/Configured.h
    config/EtcTable.cc
    config/EtcTable.h
    config/JSONConfiguration.h
    config/LibEcKit.cc
    config/LibEcKit.h
    config/LocalConfiguration.cc
    config/LocalConfiguration.h
    config/Parametrisation.cc
    config/Parametrisation.h
    config/Resource.h
    config/ResourceBase.cc
    config/ResourceBase.h
    config/ResourceMgr.cc
    config/ResourceMgr.h
    config/YAMLConfiguration.cc
    config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
    runtime/Application.cc
    runtime/Application.h
    runtime/Dispatcher.h
    runtime/Library.cc
    runtime/Library.h
    runtime/Main.cc
    runtime/Main.h
    runtime/Metrics.cc
    runtime/Metrics.h
    runtime/Monitor.cc
    runtime/Monitor.h
    runtime/Monitorable.cc
    runtime/Monitorable.h
    runtime/Pipe.h
    runtime/PipeApplication.cc
    runtime/PipeApplication.h
    runtime/PipeHandler.cc
    runtime/PipeHandler.h
    runtime/ProcessControler.cc
    runtime/ProcessControler.h
    runtime/ProducerConsumer.h
    runtime/Telemetry.cc
    runtime/Telemetry.h
    runtime/SessionID.cc
    runtime/SessionID.h
    runtime/Task.cc
    runtime/Task.h
    runtime/TaskID.h
    runtime/TaskInfo.cc
    runtime/TaskInfo.h
    runtime/Tool.cc
    runtime/Tool.h
)

list( APPEND eckit_log_srcs
    log/BigNum.cc
    log/BigNum.h
    log/Bytes.cc
    log/Bytes.h
    log/CallbackTarget.cc
    log/CallbackTarget.h
    log/Channel.cc
    log/Channel.h
    log/ChannelBuffer.cc
    log/ChannelBuffer.h
    log/CodeLocation.cc
    log/CodeLocation.h
    log/Colour.cc
    log/Colour.h
    log/ColouringTarget.cc
    log/ColouringTarget.h
    log/ETA.cc
    log/ETA.h
    log/FileTarget.cc
    log/FileTarget.h
    log/IndentTarget.cc
    log/IndentTarget.h
    log/JSON.cc
    log/JSON.h
    log/LineBasedTarget.cc
    log/LineBasedTarget.h
    log/Log.cc
    log/Log.h
    log/LogTarget.cc
    log/LogTarget.h
    log/MessageTarget.cc
    log/MessageTarget.h
    log/MonitorTarget.cc
    log/MonitorTarget.h
    log/Number.cc
    log/Number.h
    log/OStreamTarget.cc
    log/OStreamTarget.h
    log/Plural.h
    log/PrefixTarget.cc
    log/PrefixTarget.h
    log/Progress.cc
    log/Progress.h
    log/ProgressTimer.cc
    log/ProgressTimer.h
    log/ResourceUsage.cc
    log/ResourceUsage.h
    log/RotationTarget.cc
    log/RotationTarget.h
    log/SavedStatus.cc
    log/SavedStatus.h
    log/Seconds.cc
    log/Seconds.h
    log/Statistics.cc
    log/Statistics.h

=== tests/log/CMakeLists.txt ===
ecbuild_add_test( TARGET      eckit_test_log
                  SOURCES     test_log.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_channels
                  SOURCES     test_log_channels.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_callback
                  SOURCES     test_log_callback.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_threads
                  SOURCES     test_log_threads.cc
                  ENVIRONMENT _TEST_ECKIT_HOME=/tmp/$ENV{USER}
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_colour
                  SOURCES     test_colour.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_json
                  SOURCES     test_log_json.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_log_user_channels
                  ENABLED     OFF
                  SOURCES     test_log_user_channels.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_syslog
                  SOURCES     test_syslog.cc
                  LIBS        eckit )

=== tests/utils/CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,10 @@
                   SOURCES     test_rendezvoushash.cc
                   LIBS        eckit )
 
+ecbuild_add_test( TARGET      eckit_test_utils_rle
+                  SOURCES     test_rle.cc
+                  LIBS        eckit )
+
 ecbuild_add_test( TARGET      eckit_test_utils_compressor
                   SOURCES     test_compressor.cc
                   LIBS        eckit )

=== etc/eckit/geo/CMakeLists.txt ===
set(_files)
list(APPEND _files "grid.yaml")
list(APPEND _files "ORCA.yaml")

set(_destination "etc/eckit/geo")

install(FILES ${_files} DESTINATION ${_destination} PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

foreach(_file ${_files})
    configure_file(${_file} "${CMAKE_BINARY_DIR}/${_destination}/${_file}" COPYONLY)
endforeach()
